;;;; cl-scopes/test/test-forge

;;;; testing facility for scopes/forge

(defpackage :scopes/test-sf
  (:use :common-lisp
        :sf-builtin)
  (:local-nicknames (:forge :scopes/forge/sf) 
                    (:util :scopes/util)
                    (:t :scopes/testing))
  (:export #:run)
  (:import-from :scopes/testing #:deftest #:==))

(in-package :scopes/test-sf)

(defun run ()
  (let ((t:*test-suite* (t:test-suite "forge/sf")))
        ;(forge:*forge-env* (forge:forge-env)))
    ;(setf forge:*forge-env* (forge:forge-env))
    ;(forge:setup-builtins)
    (test-exec)))
 
(deftest test-exec ()
  ;(forge:exec-str "4 2 add")
  (forge:exec-list '(4 2 add))
  (== (forge:popd) 6)
  (forge:exec-list '(<comp dup mul))
  (util:lgi forge:*stack*)
  (forge:exec-list '(in square reg))
  (forge:exec-list '(7 square))
  (== (forge:popd) 49)
  (t:show-result))


